"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prompter = void 0;
var process_1 = __importDefault(require("process"));
var fs_1 = __importDefault(require("fs"));
var custom_commit_types_1 = __importDefault(require("./custom-commit-types"));
var longest = require("longest");
var commitTypes = require("conventional-commit-types");
var commitizen = require("commitizen");
var gitconfig = require("gitconfig");
var config = commitizen.configLoader.load() || {};
var length = longest(Object.keys(commitTypes.types)).length + 1;
var options = {
    defaultType: process_1.default.env.CZ_TYPE || config.defaultType,
    defaultIssue: process_1.default.env.CZ_ISSUE || config.defaultIssue,
    emailDomain: config.emailDomain,
    userRole: config.userRole,
};
var roleCustomCommitType = options.userRole === 'ops' ? custom_commit_types_1.default.ops : custom_commit_types_1.default.dev;
var types = Object.entries(__assign(__assign({}, commitTypes.types), roleCustomCommitType))
    .map(function (_a) {
    var key = _a[0], value = _a[1];
    return {
        name: (key + ':').padEnd(length) + ' ' + value.description,
        value: key
    };
});
var validateEmail = function (email) {
    var regExp = RegExp(".*?@" + options.emailDomain);
    if (!regExp.test(email)) {
        console.error("invalid email:", email);
        process_1.default.exit(1);
    }
};
function cacheAnswer(answer) {
    config.defaultIssue = answer.issue;
    config.defaultType = answer.type;
    var homedir = require('os').homedir();
    fs_1.default.writeFile(homedir + "/.czrc", JSON.stringify(config), function () {
    });
}
var prompter = function (cz, commit) { return __awaiter(void 0, void 0, void 0, function () {
    var user;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, gitconfig.get({ location: 'global' }).then(function (config) { return config.user; })];
            case 1:
                user = _a.sent();
                // register searchable list plugin;
                cz.registerPrompt('search-list', require('inquirer-search-list'));
                cz.prompt([{
                        name: 'issue',
                        type: 'input',
                        message: 'Input jira issue key:',
                        default: options.defaultIssue
                    }, {
                        type: 'search-list',
                        name: 'type',
                        message: "Select the type of change that you're committing:",
                        choices: types,
                        default: options.defaultType
                    }, {
                        name: 'body',
                        type: 'input',
                        message: 'Input message content:',
                    }])
                    .then(function (answer) {
                    validateEmail(user.email);
                    cacheAnswer(answer);
                    commit("[" + user.name + "] #" + answer.issue + " " + answer.type + ": " + answer.body);
                });
                return [2 /*return*/];
        }
    });
}); };
exports.prompter = prompter;
